luamirageat        = { }

luamirageat.module = {
   name           = "luamirageat",
   version        = 0.02,
   date           = "2011/03/29",
   description    = "Mirage of atmark",
   author         = "Kazuki Maeda",
   copyright      = "Kazuki Maeda",
   license        = "MIT License"
}

local error, warning, info, log = luatexbase.provides_module(luamirageat.module)

local mirage_fonts = {}

function luamirageat.replace_with_mirage(head, ...)
   local cn = head
   repeat
      if node.has_attribute(cn, luatexbase.attributes['lma@mirageattr']) and
         node.type(cn.id) == "glyph" and
         cn.char == string.byte('@') then
         if not mirage_fonts[cn.font] then
            local fontdata = font.getfont(cn.font)
            fontdata.characters[string.byte(' ')] = fontdata.characters[string.byte('@')]
            fontdata.characters[string.byte(' ')].tounicode = "0020006100740020"
            fontdata.fullname = fontdata.fullname .. "-mirage"
            mirage_fonts[cn.font] = font.define(fontdata)
         end
         cn.font = mirage_fonts[cn.font]
         cn.char = string.byte(' ')
      end
      cn = node.next(cn)
   until not cn
   return head
end
